<template>
  <div
    :class="{'-hide-list': !isViewExpanded}"
    class="entitiesList -custom-scroll">
    <button
      @click="toggleView"
      class="buttonExpanded">
      <img
        svg-inline
        src="~/assets/svg/redesign/rectangle.svg">
    </button>
    <ul
      class="entitiesList-tabs"
      :class="{ '_single': Object.keys(tabs).length === 1 }">
      <template v-for="(tab, key) in tabs">
        <li
          if=""
          :key="`tab-${key}`"
          class="entitiesList-tab"
          :class="{'-active': key === activeTab}">
          <slot name="tab-name">
            <button
              @click="toggleTabs(key)"
              class="buttonTab">
              {{ tab.name }}
              <span class="counter">{{ tab.count }}</span>
            </button>
          </slot>
        </li>
      </template>
    </ul>

    <slot
      v-if="!onlyTabs"
      name="sorting"/>

    <slot
      name="active-entity"
      v-if="isMobile() && !isViewExpanded && !onlyTabs"/>

    <div
      v-if="!onlyTabs"
      class="entitiesList-list">
      <VirtualList
        v-if="entities.length"
        :size="isMobile() ? 108 : 147"
        :remain="3"
        :start="listItemScrollPosition"
        :itemcount="entities.length"
      >
        <slot
          v-for="(entity, index) of entities"
          name="item"
          :idx="index"
          :active="getEntityActiveStatus(index)"
          :id="entity.id"
        />
      </VirtualList>
      <slot
        v-else
        name="warning"/>
    </div>
  </div>
</template>

<script>
import VirtualList from 'vue-virtual-scroll-list';
import isMobileMixin from '~/assets/js/mixins/is-mobile';

export default {
  name: 'AppEntitiesList',
  components: {
    VirtualList,
  },
  mixins: [isMobileMixin],
  props: {
    entities: {
      type: Array,
      default() { return []; },
    },
    entityComponent: {
      type: Object,
      default() { return null; },
    },
    activeEntityIndex: {
      type: Number,
      default: 0,
    },
    tabs: {
      type: Object,
      default() { return {}; },
    },
    activeTab: {
      type: String,
      default: '',
    },
    bus: {
      type: Object,
      required: true,
    },
    hasList: {
      type: Boolean,
      default: false,
    },
    interacted: {
      type: Boolean,
      default: false,
    },
    onlyTabs: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      isViewExpanded: this.hasList,
      listItemScrollPosition: 0,
    };
  },
  mounted() {
    this.bus.$on('select-entity', ([itemIndex = 0]) => {
      this.listItemScrollPosition = itemIndex > 2 ? itemIndex - 1 : itemIndex;
    });
  },
  destroyed() {
    this.bus.$off('select-entity');
  },
  methods: {
    toggleTabs(tab) {
      this.$emit('toggle-tab', tab);
    },
    toggleView() {
      this.isViewExpanded = !this.isViewExpanded;
      this.$emit('has-list', this.isViewExpanded);
    },
    getEntityProp(itemIndex) {
      return this.entities[itemIndex];
    },
    getEntityActiveStatus(itemIndex) {
      return this.activeEntityIndex === itemIndex;
    },
  },
};
</script>

<style scoped lang="postcss">
  @import '~/assets/css/components/scroll.css';

  .buttonTab {
    display: flex;
    justify-content: center;
    align-items: center;
    width: 100%;
    font-size: 0.875rem;
    font-weight: var(--font-weight-medium);
    color: inherit;
    background: none;
    border: none;
    outline: none;
    cursor: pointer;

    .counter {
      margin-left: 0.5rem;
      margin-top: 0.125rem;
    }

    @media screen and (max-width: 980px) {
      align-items: flex-start;
      padding: 0 1.25rem;
      font-size: 0.875rem;
    }
  }

  .buttonExpanded {
    display: none;
    @media screen and (max-width: 980px) {
      position: relative;
      display: block;
      padding: 1rem 1.25rem 1.25rem;
      width: 100%;
      background: none;
      border: none;
      outline: none;
    }
  }

  .entitiesList {
    display: flex;
    flex-direction: column;
    margin-left: 3rem;
    width: 27rem;
    height: auto;
    border-top-right-radius: 0.25rem;
    border-top-left-radius: 0.25rem;
    border: 1px solid var(--color-disabled);
    background-color: var(--bg-main);
    overflow: hidden;

    &-tabs {
      display: flex;
      flex-shrink: 0;
      margin-bottom: 1px;
      height: 3rem;
    }

    &-tab {
      display: flex;
      margin: -1px;
      width: 100%;
      color: var(--color-main-lightest);
      transition: box-shadow 0.2s var(--transition-easeOutQuad), color 0.1s var(--transition-easeOutQuad);
    }

    &-list {
      width: 100%;
      height: 100%;
      min-height: 27.56rem;
      border-top: 1px solid var(--color-disabled);
      transition: height 0.2s var(--transition-easeOutQuad);
      -webkit-overflow-scrolling: touch;
    }

    &-options {
      display: flex;
      flex-shrink: 0;
      justify-content: flex-end;
    }

    @media screen and (min-width: 981px) {
      &-tab {
        border: 1px solid var(--color-disabled);
        box-shadow: var(--form-shadow);

        &.-active {
          color: var(--color-main);
          box-shadow: none;
          border-color: transparent;
          pointer-events: none;
        }
      }
    }

    @media screen and (max-width: 980px) {
      margin: 0;
      width: 100vw;
      min-width: 20rem;
      height: auto;
      border-radius: 0;
      border: none;
      box-shadow: 0 -1px 2px rgba(0, 0, 0, 0.2);
      transition: none;

      &-list {
        margin-top: -1px;
        display: block;
        min-height: auto;
        visibility: visible;
        transition: min-height ease-in 0.3s, visibility ease-in 0.3s;
      }

      &-tabs {
        margin: 0;
        padding: 0 1.25rem;
        height: var(--btn-height-huge);

        &._single {
          margin-top: -2rem;
          border-bottom: 1px solid var(--border-color-main);

          .entitiesList-tab.-active {
            margin: 0;
            color: var(--color-main);
            background-color: var(--bg-main);
            border: none;
            box-shadow: none;
          }
        }
      }

      &-tab {
        border: 1px solid var(--border-color-main);

        &:first-of-type {
          border-top-left-radius: 0.25rem;
          border-bottom-left-radius: 0.25rem;
        }

        &:last-of-type {
          border-top-right-radius: 0.25rem;
          border-bottom-right-radius: 0.25rem;
        }

        &.-active {
          color: var(--color-main);
          background-color: var(--form-switch-active-bg);
          box-shadow: var(--form-shadow);
          pointer-events: none;
        }
      }

      &.-hide-list {
        .entitiesList-options,
        .entitiesList-list {
          height: 0;
          min-height: 0;
          padding: 0;
          margin: 0;
          border: none;
          visibility: hidden;
        }
      }
    }
  }
</style>
